;================================================
; ~ ~ ~ FRECCE ~ ~ ~ > Mathieu Bosi  2007 A.D.
;================================================


;====================================
sr = 44100
ksmps = 10

; $$$$$$$$$$$$$$$$$$$$$$$$
nchnls = 4
;nchnls = 8

;====================================

; 4Ch reverb globals
ga1 init 0
ga2 init 0
ga3 init 0
ga4 init 0

; 8Ch reverb globals
gao1 init 0
gao2 init 0
gao3 init 0
gao4 init 0
gao5 init 0
gao6 init 0
gao7 init 0
gao8 init 0


;==========================
; POSIZIONI ALTOPARLANTI ( 4Ch )
;==========================
;
; Sistema di riferimento:
;
;     ^ Y
; 1   |    2
;     |
; ----O----> X
;     |
; 3   |    4

; a1 = -1,  1
; a2 =  1,  1
; a3 = -1, -1
; a4 =  1, -1

; Distanze fra altoparlanti ( UDM in metri )
gi_spkdistX init 2.0
gi_spkdistY init 3.0
gi_spkdist_kx  init  2.0 / gi_spkdistX
gi_spkdist_ky  init  2.0 / gi_spkdistY



;-------------------------------------------------------
; Spazializzatore a 8 canali
;-------------------------------------------------------

; OPCODE Stuff:
; - opcode name, outtypes, intypes
; - xin should precede xout
opcode  Space8,  aaaaaaaa, akkk
; [ p2, p3 e parametri MIDI ereditati dallo strumento chiamante ]

;  asig     = p4	; input signal
;  isp_send = p5	; reverb send level
;  kx 	   = p6	; sound x poisition
;  ky 	   = p7	; sound y poisition

asig, kspsend, kx, ky	xin
  
  
  ; Main corners speakers:
  a1, a2, a3, a4     space  asig, 0, 0, kspsend, kx, ky
  ar1, ar2, ar3, ar4 spsend        ; reverb send 
  
  ; Reverb send:
  gao1 = gao1+ar1
  gao2 = gao2+ar2
  gao3 = gao3+ar3
  gao4 = gao4+ar4

; - - - - - - - - - - - - - - - -
  
  ; Rotate the reference frame:
  ic = cos( 45.0 * (3.1415926 / 180.0) )
  is = sin( 45.0 * (3.1415926 / 180.0) )  
  
   kxt = kx * ic  +  ky * is
   kyt = kx * is  -  ky * ic
  
  ; Edge speakers:
  a1t, a2t, a3t, a4t	space  asig, 0, 0, kspsend, kxt, kyt
  ar1, ar2, ar3, ar4	spsend
  
  ; Reverb send:
  gao5 = gao5+ar1
  gao6 = gao6+ar2
  gao7 = gao7+ar3
  gao8 = gao8+ar4 
  
; Final dry output: 

;   xout a1, a2, a3, a4,  a1t, a2t, a3t, a4t ; Separed ( for 4Ch mapping compatibility ) 
  xout a1, a2t, a2, a3t, a3, a4t, a4, a1t  ; Interleaved
 
endop


;-------------------------------------------------------
; Suono test circolare multicanale
;-------------------------------------------------------
instr rotatore_suono

  iraggio	= p4
  irivoluzioni	= p5
  
  kang  line 0.0, p3, 6.283185307 * irivoluzioni
  
  kx = -cos( kang ) * iraggio ; -cos(x) to start from Left
  ky =  sin( kang ) * iraggio
  
  asig rand 1000
  asig tone asig, 1000

; $$$$$$$$$$$$$$$$$$$$$$$$
  ; SPATIALIZATION ( 4Ch ):
  a1, a2, a3, a4     space  asig, 0, 0, .005, kx, ky
  ar1, ar2, ar3, ar4 spsend        ; reverb send
  
  ga1 = ga1+ar1
  ga2 = ga2+ar2
  ga3 = ga3+ar3
  ga4 = ga4+ar4
    
  outq a1, a2, a3, a4
; SPATIALIZATION ( 8Ch ):
  ;a1, a2, a3, a4, a5, a6, a7, a8  Space8  asig, 0.002,  kx, ky
  ;outo a1, a2, a3, a4, a5, a6, a7, a8
  
endin


;-------------------------------------------------------
; Freccia
;-------------------------------------------------------
instr 1, freccia

  iamp  = ampdb(p4) 
  ifreq = p5
  
  ix_start = p6 * gi_spkdist_kx
  iy_start = p7 * gi_spkdist_ky
  
  ix_end = p8 * gi_spkdist_kx
  iy_end = p9 * gi_spkdist_ky 
  
  ifreq_start = ifreq*1.8
  ifreq_end   = ifreq*(1.0/1.8) 


  ; XY position
  kx	 line	ix_start, p3, ix_end
  ky     line	iy_start, p3, iy_end
  kamp	 expseg	.00001, .1, iamp, p3-.11, iamp, .01, .00001

  kpitch expseg	ifreq_start, p3, ifreq_end
  
  asig	rand   kamp, 0, 0
  
  kdist spdist 0, 0, kx, ky
  
  asig = asig / (2.0*kdist*kdist+1.0)
  
  asig  reson asig/6.0, kpitch, ifreq*.5
  asig  atone asig, 1200
  asig  atone asig, 1200
  asig  tone  asig, 3000
  
  ; $$$$$$$$$$$$$$$$$$$$$$$$
  ; SPATIALIZATION ( 4Ch ):
  a1, a2, a3, a4     space  asig, 0, 0, .005, kx, ky
  ar1, ar2, ar3, ar4 spsend        ; reverb send
  
  ga1 = ga1+ar1
  ga2 = ga2+ar2
  ga3 = ga3+ar3
  ga4 = ga4+ar4
  
  outq a1, a2, a3, a4
  ;outs a1, a2

  ; SPATIALIZATION ( 8Ch ):
  ;a1, a2, a3, a4, a5, a6, a7, a8  Space8  asig1, .002,  kx, ky
  
  ;outo a1, a2, a3, a4, a5, a6, a7, a8
  
  
endin

;-------------------------------------------------------
; Freccia - Impatti
;-------------------------------------------------------
instr 2, freccia_impatti
  kamp = 20000.0
  ifn  = p4
  kcps = p5
  kx = p6
  ky = p7

  asig0 loscil kamp, kcps, ifn, 1.0
  
  kdist spdist 0, 0, kx, ky
  
  asig = asig0 / (kdist*kdist+1.0)

  ; $$$$$$$$$$$$$$$$$$$$$$$$
  ; SPATIALIZATION ( 4Ch ):
  a1, a2, a3, a4     space  asig, 0, 0, .002, kx, ky
  ar1, ar2, ar3, ar4 spsend        ; reverb send
  
   ga1 = ga1+ar1
   ga2 = ga2+ar2
   ga3 = ga3+ar3
   ga4 = ga4+ar4
  
  outq a1, a2, a3, a4
   ;outs a1, a2
  
  ; SPATIALIZATION ( 8Ch ):
  ;a1, a2, a3, a4, a5, a6, a7, a8  Space8  asig, .002,  kx, ky
  
  ;outo a1, a2, a3, a4, a5, a6, a7, a8  
   
endin




;-------------------------------------------------------
instr Riverbero4Ch
;-------------------------------------------------------          
  a1 reverb2 ga1, 2.5, .5
  a2 reverb2 ga2, 2.5, .5
  a3 reverb2 ga3, 2.5, .5
  a4 reverb2 ga4, 2.5, .5
  
  ; $$$$$$$$$$$$$$$$$$$$$$$$
  outq a1, a2, a3, a4
  ;outs a1, a2
     
  ga1=0
  ga2=0
  ga3=0
  ga4=0
endin

;-------------------------------------------------------
instr Riverbero8Ch
;-------------------------------------------------------          
  a1 reverb2 gao1, 2.5, .5
  a2 reverb2 gao2, 2.5, .5
  a3 reverb2 gao3, 2.5, .5
  a4 reverb2 gao4, 2.5, .5
  
  a5 reverb2 gao5, 2.5, .5
  a6 reverb2 gao6, 2.5, .5
  a7 reverb2 gao7, 2.5, .5
  a8 reverb2 gao8, 2.5, .5  
  ; $$$$$$$$$$$$$$$$$$$$$$$$
     ;outo a1, a2, a3, a4, a5, a6, a7, a8
     ;outs a1, a2
     
  gao1=0
  gao2=0
  gao3=0
  gao4=0
  
  gao5=0
  gao6=0
  gao7=0
  gao8=0

endin